/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.PekerjaanDao;
import com.portofolio.dto.PekerjaanDto;
import com.portofolio.entity.Pekerjaan;
import com.portofolio.entity.vo.PekerjaanId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class PekerjaanService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private PekerjaanDao pekerjaanDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(PekerjaanDto pekerjaanDto) {
		result.clear();
		PekerjaanId id = new PekerjaanId();
		Integer kdPekerjaan =getIdTerahir(Pekerjaan.class.getSimpleName());
		id.setKdPekerjaan(kdPekerjaan);
		id.setKdProfile(getKdProfile());
		Pekerjaan pekerjaan = CommonUtil.findOne(pekerjaanDao, id);
		if (CommonUtil.isNullOrEmpty(pekerjaan)) {
			pekerjaan = new Pekerjaan();
			BeanUtils.copyProperties(pekerjaanDto, pekerjaan);
			pekerjaan.setNoRec(generateUuid32());
			pekerjaan.setVersion(1);
			pekerjaan.setId(id);
			pekerjaan = pekerjaanDao.save(pekerjaan);
			result.put("pekerjaan", pekerjaan);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("pekerjaan.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(PekerjaanDto pekerjaanDto, Integer kdPekerjaan, Integer version) {
		result.clear();
		PekerjaanId id = new PekerjaanId();
		id.setKdPekerjaan(kdPekerjaan);
		id.setKdProfile(getKdProfile());
		Pekerjaan pekerjaan = CommonUtil.findOne(pekerjaanDao, id);
		if (CommonUtil.isNotNullOrEmpty(pekerjaan)) {
			if (version < pekerjaan.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(pekerjaanDto, pekerjaan);
			pekerjaan.setVersion(version);
			pekerjaan = pekerjaanDao.save(pekerjaan);
			result.put("pekerjaan", pekerjaan);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaPekerjaan,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaPekerjaan)) {
			pageRes = pekerjaanDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = pekerjaanDao.findAllList(getKdProfile(), namaPekerjaan, statusEnabled, pageReq);
		}
		result.put("pekerjaan", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdPekerjaan(Integer kdPekerjaan) {
		result.clear();
		result.put("pekerjaan", pekerjaanDao.findByKdPekerjaan(getKdProfile(), kdPekerjaan, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdPekerjaan, Integer version) {
		result.clear();
		PekerjaanId id = new PekerjaanId();
		id.setKdPekerjaan(kdPekerjaan);
		id.setKdProfile(getKdProfile());
		Pekerjaan pekerjaan = CommonUtil.findOne(pekerjaanDao, id);
		if (CommonUtil.isNotNullOrEmpty(pekerjaan)) {
			if (version < pekerjaan.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			pekerjaan.setStatusEnabled(false);
			pekerjaan.setVersion(version);
			pekerjaan = pekerjaanDao.save(pekerjaan);
			result.put("pekerjaan", pekerjaan);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
